librime: rime::LevelDb Class Reference

| librime 1.2 Rime Input Method Engine, the core library

Public Member Functions | List of all members
rime::LevelDb Class Reference

`#include <level_db.h>`

Inheritance diagram for rime::LevelDb:
[legend]
Collaboration diagram for rime::LevelDb:
[legend]

## Public Member Functions
| LevelDb (const path &file_path, const string &db_name, const string &db_type="")
virtual | ~LevelDb ()
bool | Remove () override
bool | Open () override
bool | OpenReadOnly () override
bool | Close () override
bool | Backup (const path &snapshot_file) override
bool | Restore (const path &snapshot_file) override
bool | CreateMetadata () override
bool | MetaFetch (const string &key, string *value) override
bool | MetaUpdate (const string &key, const string &value) override
an< DbAccessor > | QueryMetadata () override
an< DbAccessor > | QueryAll () override
an< DbAccessor > | Query (const string &key) override
bool | Fetch (const string &key, string *value) override
bool | Update (const string &key, const string &value) override
bool | Erase (const string &key) override
bool | Recover () override
bool | BeginTransaction () override
bool | AbortTransaction () override
bool | CommitTransaction () override
Public Member Functions inherited from rime::Db
| Db (const path &file_path, const string &name)
virtual | ~Db ()=default
RIME_DLL bool | Exists () const
const string & | name () const
const path & | file_path () const
bool | loaded () const
bool | readonly () const
bool | disabled () const
void | disable ()
void | enable ()
Public Member Functions inherited from rime::Recoverable
virtual | ~Recoverable ()=default
Public Member Functions inherited from rime::Transactional
| Transactional ()=default
virtual | ~Transactional ()=default
bool | in_transaction () const

## Additional Inherited Members
Public Types inherited from rime::Class< Db, const string & >
using | Initializer
Static Public Member Functions inherited from rime::Class< Db, const string & >
static Component * | Require (const string &name)
Protected Attributes inherited from rime::Db
string | name_
path | file_path_
bool | loaded_ = false
bool | readonly_ = false
bool | disabled_ = false
Protected Attributes inherited from rime::Transactional
bool | in_transaction_ = false

## Constructor & Destructor Documentation

## ◆ LevelDb()

rime::LevelDb::LevelDb | ( | const path & | file_path,
|  | const string & | db_name,
|  | const string & | db_type = "" )

## ◆ ~LevelDb()

rime::LevelDb::~LevelDb | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ AbortTransaction()

bool rime::LevelDb::AbortTransaction | ( |  | ) |
| overridevirtual

Reimplemented from rime::Transactional.

## ◆ Backup()

bool rime::LevelDb::Backup | ( | const path & | snapshot_file | ) |
| overridevirtual

Implements rime::Db.

## ◆ BeginTransaction()

bool rime::LevelDb::BeginTransaction | ( |  | ) |
| overridevirtual

Reimplemented from rime::Transactional.

## ◆ Close()

bool rime::LevelDb::Close | ( |  | ) |
| overridevirtual

Implements rime::Db.

## ◆ CommitTransaction()

bool rime::LevelDb::CommitTransaction | ( |  | ) |
| overridevirtual

Reimplemented from rime::Transactional.

## ◆ CreateMetadata()

bool rime::LevelDb::CreateMetadata | ( |  | ) |
| overridevirtual

Reimplemented from rime::Db.

## ◆ Erase()

bool rime::LevelDb::Erase | ( | const string & | key | ) |
| overridevirtual

Implements rime::Db.

## ◆ Fetch()

bool rime::LevelDb::Fetch | ( | const string & | key,
|  | string * | value )
| overridevirtual

Implements rime::Db.

## ◆ MetaFetch()

bool rime::LevelDb::MetaFetch | ( | const string & | key,
|  | string * | value )
| overridevirtual

Implements rime::Db.

## ◆ MetaUpdate()

bool rime::LevelDb::MetaUpdate | ( | const string & | key,
|  | const string & | value )
| overridevirtual

Implements rime::Db.

## ◆ Open()

bool rime::LevelDb::Open | ( |  | ) |
| overridevirtual

Implements rime::Db.

## ◆ OpenReadOnly()

bool rime::LevelDb::OpenReadOnly | ( |  | ) |
| overridevirtual

Implements rime::Db.

## ◆ Query()

an< DbAccessor > rime::LevelDb::Query | ( | const string & | key | ) |
| overridevirtual

Implements rime::Db.

## ◆ QueryAll()

an< DbAccessor > rime::LevelDb::QueryAll | ( |  | ) |
| overridevirtual

Implements rime::Db.

## ◆ QueryMetadata()

an< DbAccessor > rime::LevelDb::QueryMetadata | ( |  | ) |
| overridevirtual

Implements rime::Db.

## ◆ Recover()

bool rime::LevelDb::Recover | ( |  | ) |
| overridevirtual

Implements rime::Recoverable.

## ◆ Remove()

bool rime::LevelDb::Remove | ( |  | ) |
| overridevirtual

Reimplemented from rime::Db.

## ◆ Restore()

bool rime::LevelDb::Restore | ( | const path & | snapshot_file | ) |
| overridevirtual

Implements rime::Db.

## ◆ Update()

bool rime::LevelDb::Update | ( | const string & | key,
|  | const string & | value )
| overridevirtual

Implements rime::Db.

The documentation for this class was generated from the following files:

- level_db.h
- level_db.cc